Subject: Re: [Isis-wg] [IS-IS WG] Subsecond Timers

From: "Ian Duncan" <[email-masked]>
Date: Tue, 09 Jan 2001 14:16:18 -0500

Tony Przygienda wrote:
> 
> >
> > >
> > > Given the current run-to-completion operating system
> > > schedulers that we all
> > > seem to use, you basically have two choices: either try to run to
> > > completion with MUCH tighter timers throughout the ENTIRE
> > > operating system
> > > or convert to a pre-emptive scheduling mechanism.  Both are
> > > fraught with
> > > risk.
> > >
> >
> > If implementation of "very tight timers" is a real big issue (and I'll
> > gladly take your word for that), how does this relate to protocols like LMP?
> > This relies on timers in the milli-second range, which is hard, if not
> > impossible if I understand correctly. Would these protocols (FLIP is the
> > other I believe) require a complete re-do of the router OS, or can they
> > implemented in another way.
> 
> this is a very deep question to which a simplistic answer is "depends on
> the layer". Analogy: it is hard to handle interrupts in unix user space,
> not so hard in well-written kernel drivers.  Therefore certain protocols, especially
> those very close to hardware (e.g. BLSR ;-) can run in a very fine resolution.

Sorry for the long delay, I was in another meta timezone for the past 
few weeks ...

In the case of FLIP this isn't truly a deep question as thought/effort was
put to make it relatively unheroic to implement. The adjacency and the "hello" 
messages are easily distinguished in a router "fast path" and the "hello" is 
designed to be simple to turn around either in hardware or low level software, 
i.e. in fastpath micro-code or a kernel interrupt handler.

By delegating robust fast failure detection to FLIP I believe we can avoid much 
messing about with existing routing code. We'd also provide for two or more 
higher level protocols to have fast detection over the same adjacency without 
duplicating work, e.g. ISIS and LDP.

/id
_______________________________________________
Isis-wg mailing list  -  [email-masked]
http://external.juniper.net/mailman/listinfo/isis-wg